Ruby - Bug #17021

"arm64" and "arm" are mixed in RbConfig on Apple silicon
07/09/2020 11:57 AM - watson1978 (Shizuo Fujita)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v:

ruby 2.8.0dev (2020-07-09T09:14:53Z
master addbb7d16e) [arm64-darwin20]

Backport: 2.5: REQUIRED, 2.6: REQUIRED, 2.7:

REQUIRED, 3.0: DONTNEED

Description

When | checked the value of RbConfig::CONFIG on the Apple silicon macOS,e | found "arm64" and "arm" are mixed as following.

$ ruby -v
ruby 2.8.0dev

(2020-07-09T09:14:5372 master addbb7dloee)

[arm64—-darwin20]

$ ruby -e 'require "rbconfig"; pp RbConfig::CONFIG' | grep "arm"
"/Users/watson/.rbenv/versions/2.8.0/include/ruby-2.8.0/vendor_ruby/arm64-darwin20",
"/Users/watson/.rbenv/versions/2.8.0/include/ruby-2.8.0/site_ruby/arm64-darwin20",
"/Users/watson/.rbenv/versions/2.8.0/include/ruby-2.8.0/armé64-darwin20",
"/Users/watson/.rbenv/versions/2.8.0/1ib/ruby/vendor_ruby/2.8.0/arm64-darwin20",
"/Users/watson/.rbenv/versions/2.8.0/1ib/ruby/site_ruby/2.8.0/arm64-darwin20",
"/Users/watson/.rbenv/versions/2.8.0/1ib/ruby/2.8.0/arm64-darwin20",

sitearch"=>"arm64-darwin20",

"arch"=>"arm64-darwin20",

"/Users/watson/.rbenv/versions/2.8.0/include/arm64-darwin20",

"/Users/watson/.rbenv/versions/2.8.0/include/arm64-darwin20",
"sitearchlibdir"=>"/Users/watson/.rbenv/versions/2.8.0/1lib/arm64-darwin20",
"archlibdir"=>"/Users/watson/.rbenv/versions/2.8.0/1lib/arm64-darwin20",

"/Users/watson/.rbenv/versions/2.8.0/1ib/ruby/arm64-darwin20",
"/Users/watson/.rbenv/versions/2.8.0/1ib/ruby/arm64-darwin20",

"Target:

"target_cpu"=>"armé64",

"target"=>"arm64-

apple-darwin20",

"host_cpu"=>"arm",

"host"=>"arm-apple-darwin20.0.0",

"build_cpu"=>"arm",

"build"=>"arm-apple-darwin20.0.0",

armé64-apple-darwin20.0.0\n" +

"/Users/watson/.rbenv/versions/2.8.0/1ib/ruby/2.8.0/arm64-darwin20",
"topdir"=>"/Users/watson/.rbenv/versions/2.8.0/1ib/ruby/2.8.0/arm64-darwin20"}

"target_cpu" indicates "armé4", however, "host_cpu" has "arm"...

I'd like to know whether this behavior is the right thing.

Related issues:

Related to Ruby - Bug #3565: make test-all fails to run

Related to Ruby - Bug #17605: Please backport Apple Silicon arm64 vs arm bugf...

Closed
Closed

07/13/2010

Associated revisions

Revision 43a9a974e276dc49b03ec81ccace0adb534a3d20 - 11/21/2020 02:21 PM - nobu (Nobuyoshi Nakada)
[Bug #17021] Make host_* values consistent with target_*

Revision 43a9a974e276dc49b03ec81ccace0adb534a3d20 - 11/21/2020 02:21 PM - nobu (Nobuyoshi Nakada)
[Bug #17021] Make host_* values consistent with target_*

Revision 43a9a974 - 11/21/2020 02:21 PM - nobu (Nobuyoshi Nakada)

[Bug #17021] Make host_* values consistent with target_*

Revision f03ba00f40e7c964efcfffc7a761074800ecc1a4 - 02/11/2021 04:52 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 43a9a974e276dc49b03ec81ccace0adb534a3d20: [Backport #17021] [Backport #17605]

[Bug #17021] Make host_* values consistent with target_*

configure.ac | 7 ++++++-
1 file changed, 6 insertions(+), 1 deletion(-)

Revision f03ba00f40e7c964efcfffc7a761074800ecc1a4 - 02/11/2021 04:52 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 43a9a974e276dc49b03ec81ccace0adb534a3d20: [Backport #17021] [Backport #17605]

[Bug #17021] Make host_* values consistent with target_*

configure.ac | 7 ++++++-
1 file changed, 6 insertions(+), 1 deletion(-)

Revision f03ba00f - 02/11/2021 04:52 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 43a9a974e276dc49b03ec81ccace0adb534a3d20: [Backport #17021] [Backport #17605]

[Bug #17021] Make host_* wvalues consistent with target_*

configure.ac | 7 ++++++-
1 file changed, 6 insertions(+), 1 deletion(-)

History

#1 - 08/03/2020 07:56 PM - larskanis (Lars Kanis)

IMHO, "host_cpu" should have "arm64". "arm" looks like a bug to me. Would be nice to get this resolved, since it blocks
https://github.com/ffi/ffi/pull/801 .

#2 - 11/17/2020 10:20 AM - Eregon (Benoit Daloze)

This seems a clear bug, at least host_cpu and build_cpu.
arm means 32-bit and is already used e.g. on Linux to mean that.

So it should be arm64 or aarch64.

target_cpu is already arm64 interestingly.
@nobu (Nobuyoshi Nakada) Do you know if we could fix that and how?

#3 - 11/17/2020 12:35 PM - nobu (Nobuyoshi Nakada)

As | have no access to Apple silicon machines, can anyone share config.log file on that platform?

#4 - 11/17/2020 12:45 PM - nobu (Nobuyoshi Nakada)
Maybe, uname -m (and tool/config.guess) returns "arm", then RUBY_UNIVERSAL_ARCH replaces target_cpu only?

#5 - 11/18/2020 01:14 AM - nobu (Nobuyoshi Nakada)
| heard that config.guess claims it "arm", while uname -m reports "armé4".

First of all, $host_cpu and others are used only for cross-compilers and nonsense in the other cases.
Why do they matter?

#6 - 11/18/2020 09:59 AM - nobu (Nobuyoshi Nakada)
- Related to Bug #3565: make test-all fails to run added

#7 - 11/19/2020 06:51 PM - Eregon (Benoit Daloze)

nobu (Nobuyoshi Nakada) wrote in #note-5:

First of all, $host_cpu and others are used only for cross-compilers and nonsense in the other cases.
Why do they matter?

| think RbConfig host_* values should be correct no matter whether cross-compiling or not.

Notably, RbConfig::CONFIG["host_o0s"] is well known as the portable way to get the OS.
So it follows that RbConfig::CONFIG["host_cpu"] would be the portable way to get the processor architecture.
https://github.com/ffi/ffi/pull/801
https://bugs.ruby-lang.org/users/4

Both are used here: https://github.com/ffi/ffi/blob/fbe2cf851f426cc55b3b76eca7b10e37aa220b47/lib/ffi/platform.rb

Should another RbConfig::CONFIG key be used? Which one?

#8 - 11/21/2020 01:36 PM - nobu (Nobuyoshi Nakada)

Eregon (Benoit Daloze) wrote in #note-7:

Should another RbConfig::CONFIG key be used? Which one?

Usually we use target_* instead.

#9 - 11/22/2020 12:10 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

Applied in changeset git|43a9a974e276dc49b03ec81ccace0adb534a3d20.

[Bug #17021] Make host_* values consistent with target_*

#10 - 02/02/2021 03:20 PM - naruse (Yui NARUSE)
- Related to Bug #17605: Please backport Apple Silicon armé64 vs arm bugfix to 2.6 and 2.7 added

#11 - 04/05/2021 12:48 AM - nobu (Nobuyoshi Nakada)
- Backport changed from 2.5: UNKNOWN, 2.6: UNKNOWN, 2.7: UNKNOWN to 2.5: REQUIRED, 2.6: REQUIRED, 2.7: REQUIRED, 3.0: REQUIRED

#12 - 05/22/2021 06:56 AM - nagachika (Tomoyuki Chikanaga)
- Backport changed from 2.5: REQUIRED, 2.6: REQUIRED, 2.7: REQUIRED, 3.0: REQUIRED to 2.5: REQUIRED, 2.6: REQUIRED, 2.7: REQUIRED,
3.0: DONTNEED

43a9a974e276dc49b03ec81ccace0adb534a3d20 is included in ruby_3_0 branch.
https://github.com/ffi/ffi/blob/fbe2cf851f426cc55b3b76eca7b10e37aa220b47/lib/ffi/platform.rb
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/43a9a974e276dc49b03ec81ccace0adb534a3d20
https://bugs.ruby-lang.org/issues/17021
http://www.tcpdf.org

